# class Puma::Rack::URLMap

Rack::URLMap takes a hash mapping urls or paths to apps, and dispatches accordingly. Support for HTTP/1.1 host names exists if the URLs start with `http://` or `https://`.

URLMap modifies the SCRIPT_NAME and PATH_INFO such that the part relevant for dispatch is in the SCRIPT_NAME, and the rest in the PATH_INFO. This should be taken care of when you need to reconstruct the URL in order to create links.

URLMap dispatches in such a way that the longest paths are tried first, since they are most specific.

### Constants

INFINITY
NEGATIVE_INFINITY

### Public Class Methods

new(map = {}) click to toggle source

    # File lib/puma/rack/urlmap.rb, line 18
    def initialize(map = {})
      remap(map)
    end

### Public Instance Methods

call(env) click to toggle source

    # File lib/puma/rack/urlmap.rb, line 43
    def call(env)
      path = env['PATH_INFO']
      script_name = env['SCRIPT_NAME']
      http_host = env['HTTP_HOST']
      server_name = env['SERVER_NAME']
      server_port = env['SERVER_PORT']

      is_same_server = casecmp?(http_host, server_name) ||
                    casecmp?(http_host, "#{server_name}:#{server_port}")

      @mapping.each do |host, location, match, app|
        unless casecmp?(http_host, host) \
            || casecmp?(server_name, host) \
            || (!host && is_same_server)
          next
        end

        next unless m = match.match(path.to_s)

        rest = m[1]
        next unless !rest || rest.empty? || rest[0] == ?/

        env['SCRIPT_NAME'] = (script_name + location)
        env['PATH_INFO'] = rest

        return app.call(env)
      end

      [404, {'Content-Type' => "text/plain", "X-Cascade" => "pass"}, ["Not Found: #{path}"]]

    ensure
      env['PATH_INFO'] = path
      env['SCRIPT_NAME'] = script_name
    end

remap(map) click to toggle source

    # File lib/puma/rack/urlmap.rb, line 22
    def remap(map)
      @mapping = map.map { |location, app|
        if location =~ %r{\Ahttps?://(.*?)(/.*)}
          host, location = $1, $2
        else
          host = nil
        end

        unless location[0] == ?/
          raise ArgumentError, "paths need to start with /"
        end

        location = location.chomp('/')
        match = Regexp.new("^#{Regexp.quote(location).gsub('/', '/+')}(.*)", nil, 'n')

        [host, location, match, app]
      }.sort_by do |(host, location, _, _)|
        [host ? -host.size : INFINITY, -location.size]
      end
    end

### Private Instance Methods

casecmp?(v1, v2) click to toggle source

    # File lib/puma/rack/urlmap.rb, line 79
    def casecmp?(v1, v2)
      # if both nil, or they're the same string
      return true if v1 == v2

      # if either are nil... (but they're not the same)
      return false if v1.nil?
      return false if v2.nil?

      # otherwise check they're not case-insensitive the same
      v1.casecmp(v2).zero?
    end